Unit de49e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE48E_p, UTDE17_p;

procedure de49e(F :Proc_FE_DE; M :Integer; XN :Extended;
                var YN :Array of Extended; var DYN :Array of Extended;
                XK :Extended; HMIN :Extended; HMAX :Extended;
                EPS :Extended; P :Extended; var H :Extended;
                var Y :Array of Extended; var DY :Array of Extended;
                var DELTY :Array of Extended; var DF :Array of Extended;
                var RFN :Array of Extended; var RF :Array of Extended;
                var YP :Array of Extended; var DYP :Array of Extended;
                var IERR :Integer);

implementation

procedure de49e(F :Proc_FE_DE; M :Integer; XN :Extended;
                var YN :Array of Extended; var DYN :Array of Extended;
                XK :Extended; HMIN :Extended; HMAX :Extended;
                EPS :Extended; P :Extended; var H :Extended;
                var Y :Array of Extended; var DY :Array of Extended;
                var DELTY :Array of Extended; var DF :Array of Extended;
                var RFN :Array of Extended; var RF :Array of Extended;
                var YP :Array of Extended; var DYP :Array of Extended;
                var IERR :Integer);
var
I,JSTART :Integer;
H1,HS,X :Extended;
BUL :Boolean;
label
_10,_20,_30,_40,_50,_60;
begin
IERR := 0;
for I:=1 to M do
 begin
  DY[I-1] := DYN[I-1];
  Y[I-1] := YN[I-1];
_10:
 end;
if ( XN =  XK ) 
 then goto _60;
X := XN;
H := Sign(H,XK-XN);
BUL := False;
_20:
JSTART := 0;
_30:
if ( not  BUL ) 
 then goto _40;
H := HS;
goto _60;
_40:
H1 := XK - X;
if ( Abs(H1) >  Abs(H) ) 
 then goto _50;
HS := H;
H := H1;
BUL := True;
_50:
DE48E(F,M,JSTART,HMIN,HMAX,EPS,P,Y,X,DY,H,BUL,DELTY,DF,
     RFN,RF,YP,DYP,IERR);
if ( IERR =  0 ) 
 then goto _30;
UTDE17(IERR,49);
_60:
end;

end.
